From 06ef0cc99a82b525ec6c17548b1aafb7b58f060f Mon Sep 17 00:00:00 2001
From: Peti Gomori <gomoripeti@gmail.com>
Date: Fri, 29 Jun 2012 18:25:59 +0200
Subject: [PATCH 2/2] Make Table Viewer search a bit faster

Conflicts:
	lib/observer/src/observer_tv_table.erl
---
 lib/observer/src/observer_tv_table.erl |   24 ++++++++++++++----------
 1 file changed, 14 insertions(+), 10 deletions(-)

diff --git a/lib/observer/src/observer_tv_table.erl b/lib/observer/src/observer_tv_table.erl
index 231a4c3..835c7aa 100644
--- a/lib/observer/src/observer_tv_table.erl
+++ b/lib/observer/src/observer_tv_table.erl
@@ -594,7 +594,7 @@ keysort(Col, Table) ->
     lists:sort(Sort, Table).
 
 search([Str, Row, Dir0, CaseSens],
-       S=#holder{parent=Parent, table=Table}) ->
+       S=#holder{parent=Parent, table=Table0}) ->
     Opt = case CaseSens of
 	      true -> [];
 	      false -> [caseless]
@@ -605,24 +605,28 @@ search([Str, Row, Dir0, CaseSens],
 	  end,
     Res = case re:compile(Str, Opt) of
 	      {ok, Re} ->
+		  Table =
+		      case Dir0 of
+			  true ->
+			      lists:nthtail(Row, Table0);
+			  false ->
+			      lists:reverse(lists:sublist(Table0, Row+1))
+		      end,
 		  search(Row, Dir, Re, Table);
 	      {error, _} -> false
 	  end,
     Parent ! {self(), Res},
     S#holder{search=Res}.
 
-search(Row, Dir, Re, Table) ->
-    Res = try lists:nth(Row+1, Table) of
-	      Term ->
-		  Str = format(Term),
-		  re:run(Str, Re)
-	  catch _:_ -> no_more
-	  end,
+search(Row, Dir, Re, [ [Term|_] |Table]) ->
+    Str = format(Term),
+    Res = re:run(Str, Re),
     case Res of
 	nomatch -> search(Row+Dir, Dir, Re, Table);
-	no_more -> false;
 	{match,_} -> Row
-    end.
+    end;
+search(_, _, _, []) ->
+    false.
 
 get_row(From, Row, Col, Table) ->
     case lists:nth(Row+1, Table) of
-- 
1.7.10.4

